Index: modules/uoa-services-library/trunk/ng-openaire-library/src/app/searchPages/searchResearchResults.component.ts
===================================================================
--- modules/uoa-services-library/trunk/ng-openaire-library/src/app/searchPages/searchResearchResults.component.ts	(revision 58104)
+++ modules/uoa-services-library/trunk/ng-openaire-library/src/app/searchPages/searchResearchResults.component.ts	(revision 58105)
@@ -8,6 +8,7 @@
 import {SearchCustomFilter, SearchUtilsClass} from './searchUtils/searchUtils.class';
 import {EnvProperties} from '../utils/properties/env-properties';
 import {NewSearchPageComponent} from "./searchUtils/newSearchPage.component";
+import {RangeFilter} from "../utils/rangeFilter/rangeFilterHelperClasses.class";
 
 
 @Component({
@@ -30,6 +31,7 @@
       searchFormClass="publicationsSearchForm"
       [(sort)]=sort
       [(filters)]="filters" [quickFilter]="quickFilter"
+      [rangeFilters]="rangeFilters" [rangeFields]="rangeFields"
       [simpleView]="simpleView" formPlaceholderText="Search by title, author, doi, abstract content..."
     >
     </new-search-page>
@@ -49,6 +51,7 @@
   @Input() hasPrefix: boolean = true;
   public results = [];
   public filters = [];
+  public rangeFilters: RangeFilter[] = [];
 
   public searchUtils: SearchUtilsClass = new SearchUtilsClass();
   public searchFields: SearchFields = new SearchFields();
@@ -55,6 +58,7 @@
 
   public fieldIds: string[] = this.searchFields.RESULT_ADVANCED_FIELDS;
   public fieldIdsMap = this.searchFields.RESULT_FIELDS;
+  public rangeFields:string[][] = this.searchFields.RESULT_RANGE_FIELDS;
   public selectedFields: AdvancedField[] = [];
   public resourcesQuery = "((oaftype exact result) and (resulttypeid exact " + this.resultType + "))";
   public csvParams: string;
@@ -85,7 +89,7 @@
       }
 
   ngOnInit() {
-    console.log(this.quickFilter)
+    console.log(this.quickFilter);
     //TODO add checks about which result types are enabled!
     this.route.data.subscribe((data: { envSpecific: EnvProperties }) => {
       this.properties = data.envSpecific;
@@ -124,10 +128,18 @@
       }
 
       this.selectedFields = [];
-      this.searchPage.prepareSearchPage(this.fieldIds, this.selectedFields, this.refineFields, this.fieldIdsMap,this.customFilter,params, this.resultType, this.quickFilter);
-      this._getResults(this.searchPage.getSearchAPIQueryForAdvancedSearhFields(), this.searchUtils.page, this.searchUtils.size, this.searchUtils.sortBy, refine, this.searchPage.getSearchAPIQueryForRefineFields(params, firstLoad));
-      firstLoad = false;
-
+// <<<<<<< .mine
+      this.searchPage.prepareSearchPage(this.fieldIds, this.selectedFields, this.refineFields, this.rangeFields, this.fieldIdsMap,this.customFilter,params, this.resultType, this.quickFilter);
+      this._getResults(this.searchPage.getSearchAPIQueryForAdvancedSearhFields(), this.searchUtils.page, this.searchUtils.size, this.searchUtils.sortBy, refine, this.searchPage.getSearchAPIQueryForRangeFields(params)+this.searchPage.getSearchAPIQueryForRefineFields(params, firstLoad));
+// ||||||| .r58066
+//       this.searchPage.prepareSearchPage(this.fieldIds, this.selectedFields, this.refineFields, this.fieldIdsMap,this.customFilter,params);
+//       this._getResults(this.searchPage.getSearchAPIQueryForAdvancedSearhFields(), this.searchUtils.page, this.searchUtils.size, this.searchUtils.sortBy, refine, this.searchPage.getSearchAPIQueryForRefineFields(params));
+// =======
+//       this.searchPage.prepareSearchPage(this.fieldIds, this.selectedFields, this.refineFields, this.fieldIdsMap,this.customFilter,params, this.resultType, this.quickFilter);
+//       this._getResults(this.searchPage.getSearchAPIQueryForAdvancedSearhFields(), this.searchUtils.page, this.searchUtils.size, this.searchUtils.sortBy, refine, this.searchPage.getSearchAPIQueryForRefineFields(params, firstLoad));
+//       firstLoad = false;
+//
+// >>>>>>> .r58095
     });
   }
 
@@ -157,11 +169,13 @@
         data => {
           this.searchUtils.totalResults = data[0];
           this.results = data[1];
+
           if (refine) {
             this.filters = this.searchPage.prepareFiltersToShow(data[2]);
           }else{
-            this.searchPage.buildPageURLParameters(this.filters, false);
+            this.searchPage.buildPageURLParameters(this.filters, this.rangeFilters, false);
           }
+          this.rangeFilters = this.searchPage.prepareRangeFiltersToShow();
 
           this.searchUtils.status = this.errorCodes.DONE;
           if (this.searchUtils.totalResults == 0) {
Index: modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/string-utils.class.ts
===================================================================
--- modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/string-utils.class.ts	(revision 58104)
+++ modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/string-utils.class.ts	(revision 58105)
@@ -1,6 +1,9 @@
 import {UrlSegment} from '@angular/router';
 
 export class Dates {
+  public static yearMin = 1800;
+  public static yearMax = (new Date().getFullYear()) + 10;
+
   public static isValidYear(yearString){
     // First check for the pattern
     if(!/^\d{4}$/.test(yearString))
@@ -8,7 +11,7 @@
         var year = parseInt(yearString, 10);
 
         // Check the ranges of month and year
-        if(year < 1000 || year > 3000 )
+        if(year < this.yearMin || year > this.yearMax )
             return false;
         return true;
   }
Index: modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/rangeFilter.component.ts
===================================================================
--- modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/rangeFilter.component.ts	(nonexistent)
+++ modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/rangeFilter.component.ts	(revision 58105)
@@ -0,0 +1,47 @@
+import {Component, Input, Output, EventEmitter} from '@angular/core';
+import { RangeFilter } from './rangeFilterHelperClasses.class';
+import { Dates } from "../string-utils.class";
+
+@Component({
+  selector: 'range-filter',
+  templateUrl: 'rangeFilter.component.html'
+})
+
+export class RangeFilterComponent {
+
+  @Input() filter:RangeFilter;
+  @Input() isDisabled:boolean = false;
+  public _maxCharacters:number =28;
+  public focusedInput: string = "";
+  public yearMin = Dates.yearMin;
+  public yearMax = Dates.yearMax;
+
+  @Output() onFilterChange = new EventEmitter();
+
+  constructor() {}
+
+  ngOnInit() {}
+
+  public _formatTitle(title){
+    return ((title.length > this._maxCharacters)?(title.substring(0,(this._maxCharacters - ('...').length))+"..."):title);
+  }
+
+  yearChanged(){
+    this.onFilterChange.emit({
+      value: this.filter
+    });
+  }
+
+  clearFilter() {
+    this.filter.selectedFromValue = null;
+    this.filter.selectedToValue = null;
+    this.onFilterChange.emit({
+      value: this.filter
+    });
+  }
+
+  getFilterName(value){
+    let name = value.name +" ("+ value.number.format()+")";
+    return name;
+  }
+}
Index: modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/inValidYear.directive.ts
===================================================================
--- modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/inValidYear.directive.ts	(nonexistent)
+++ modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/inValidYear.directive.ts	(revision 58105)
@@ -0,0 +1,19 @@
+import { Directive, Input, OnChanges, SimpleChanges } from '@angular/core';
+import { AbstractControl, NG_VALIDATORS, Validator, ValidatorFn, Validators } from '@angular/forms';
+import { Dates } from "../string-utils.class";
+
+export function inValidYearValidator(): ValidatorFn {
+  return (control: AbstractControl): {[key: string]: any} | null => {
+    return ((control.value && !Dates.isValidYear(control.value)) ? {'inValidYear': {value: control.value}} : null);
+  };
+}
+
+@Directive({
+  selector: '[inValidYear]',
+  providers: [{provide: NG_VALIDATORS, useExisting: InValidYearValidatorDirective, multi: true}]
+})
+export class InValidYearValidatorDirective implements Validator {
+  validate(control: AbstractControl): {[key: string]: any} | null {
+    return inValidYearValidator()(control);
+  }
+}
\ No newline at end of file
Index: modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/rangeFilterHelperClasses.class.ts
===================================================================
--- modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/rangeFilterHelperClasses.class.ts	(nonexistent)
+++ modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/rangeFilterHelperClasses.class.ts	(revision 58105)
@@ -0,0 +1,30 @@
+import {Filter, Value} from "../../searchPages/searchUtils/searchHelperClasses.class";
+import {SearchFields} from "../properties/searchFields";
+
+export class RangeFilter{
+  public title: string; // eg Publication Date Range
+  public filterId: string; // type (name in url parameter)
+  public originalFilterIdFrom: string; // (in index)
+  public originalFilterIdTo: string; // (in index)
+  public selectedFromValue: string;
+  public selectedToValue: string;
+  public selectedFromAndToValues: string = "";
+
+  public static parse (fields:string[][], entityType:string,):RangeFilter[] {
+    var searchFields:SearchFields = new SearchFields();
+    var filters:RangeFilter[] = [];
+    if(fields){
+      for(let j=0; j<fields.length; j++) {
+
+        var filter:RangeFilter = new RangeFilter();
+        filter.title = searchFields.getFieldName(fields[j][0]+"-range-"+fields[j][1] ,entityType);
+        filter.filterId = searchFields.getFieldParam(fields[j][0]+"-range-"+fields[j][1] ,entityType);
+        filter.originalFilterIdFrom = fields[j][0];
+        filter.originalFilterIdTo = fields[j][1];
+        filters.push(filter);
+      }
+    }
+    return filters;
+  }
+}
+
Index: modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/rangeFilter.module.ts
===================================================================
--- modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/rangeFilter.module.ts	(nonexistent)
+++ modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/rangeFilter.module.ts	(revision 58105)
@@ -0,0 +1,23 @@
+import { NgModule}      from '@angular/core';
+import { CommonModule } from '@angular/common';
+import { FormsModule }  from '@angular/forms';
+import { RouterModule } from '@angular/router';
+
+import {RangeFilterComponent} from './rangeFilter.component';
+import {InValidYearValidatorDirective} from "./inValidYear.directive";
+import {FromYearAfterToYearValidatorDirective} from "./fromYearAfterToYear.directive";
+
+@NgModule({
+  imports: [
+    CommonModule, FormsModule, RouterModule
+  ],
+  declarations: [
+    RangeFilterComponent, InValidYearValidatorDirective, FromYearAfterToYearValidatorDirective
+  ],
+  providers:[
+  ],
+  exports: [
+    RangeFilterComponent
+  ]
+})
+export class RangeFilterModule { }
\ No newline at end of file
Index: modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/fromYearAfterToYear.directive.ts
===================================================================
--- modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/fromYearAfterToYear.directive.ts	(nonexistent)
+++ modules/uoa-services-library/trunk/ng-openaire-library/src/app/utils/rangeFilter/fromYearAfterToYear.directive.ts	(revision 58105)
@@ -0,0 +1,19 @@
+import { Directive } from '@angular/core';
+import { AbstractControl, FormGroup, NG_VALIDATORS, ValidationErrors, Validator, ValidatorFn } from '@angular/forms';
+
+export const fromYearAfterToYearValidator: ValidatorFn = (control: FormGroup): ValidationErrors | null => {
+  const yearFrom = control.get('yearFrom');
+  const yearTo = control.get('yearTo');
+
+  return ((yearFrom && yearTo && (parseInt(yearFrom.value, 10) >  parseInt(yearTo.value, 10))) ? { 'fromYearAfterToYear': true } : null);
+};
+
+@Directive({
+  selector: '[fromYearAfterToYear]',
+  providers: [{ provide: NG_VALIDATORS, useExisting: FromYearAfterToYearValidatorDirective, multi: true }]
+})
+export class FromYearAfterToYearValidatorDirective implements Validator {
+  validate(control: AbstractControl): ValidationErrors {
+    return fromYearAfterToYearValidator(control)
+  }
+}
